﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Persistence;

namespace doLogic
{
	public class Divisions : PersistentList<Division>
	{
        public static Divisions For(Client client)
        {
            return new Divisions(client.ClientCode);
        }

        public Divisions WhereNameContains(string search)
        {
            search = search.ToLower();

            Divisions divisions = new Divisions();

            foreach (Division l in this)
                if (l.DivName.ToLower().Contains(search))
                    divisions.Add(l);
            return divisions;
        }

        internal Divisions() { }

        internal Divisions(int clientCode)
        {
            ClientCode = clientCode;
            this.Load("ForClient");
        }
        public int ClientCode { get; set; }
	}

	[Persistable("Divisions", "DivID", false)]
	public class Division
	{
        public static Division Load(int divID)
        {
            Division division = new Division();
            division.DivID = divID;
            Database.Load(division);
            return division;
        }

        public static Division Load(int divID, Connection cn)
        {
            return new Division(divID, cn);
        }

		//constructors
		public Division() { }

        public Division(int divID)
        {
            this.DivID = divID;
            Database.Load(this);
        }

        private Division(int divID, Connection cn)
        {
            this.DivID = divID;
            Database.Load(this, cn);
        }

		//persistent properties
		public int DivID { get; set; }
		public int ClientCode { get; set; }
		public string DivName { get; set; }

		public int Store() { return Database.Store(this); }
		public bool Delete() { return Database.Delete(this); }
	}
}
